; processor type ATMega32, 16MHz clock speed
.include "m32def.inc"

.equ cpufreq= 16000000  // device mode
;.equ cpufreq= 0 		// debug mode

; call stack helpers
.def XPL = R24
.def XPH = R25

.macro BEGINPROC
		pop XPH
		pop XPL
.endmacro

.macro ENDPROC
		push XPL
		push XPH
		ret		
.endmacro

; macros
.include "macros.inc"

; procedural headers
.include "LCD16080HDR.inc"

; definitions
.equ LCD16080_IOPORT = PORTC	; display pins 7 .. 14
.equ LCD16080_BITS = PORTA		; PORTA0..3 as outputs, see below
.equ LCD16080_RS  = 0			; display pin4  Register Select	: Instruction / !Data
.equ LCD16080_RW  = 1			; display pin5	RW Mode 		: Read / !Write
.equ LCD16080_ENA = 2			; display pin6					  Enable
.equ LCD16080_CS  = 3			; display pin16 				  !Reset
.equ LCD16080_RST = 4

; variable declarations
.dseg

; EEPROM data
.eseg

	str01:
	.db "Hello World!",0






;---------------------------------------------------------------
; application code starts here
;---------------------------------------------------------------
.cseg

.org $0000

		rjmp BEGIN

.org $0008

	BEGIN:

 		InitStackPtr ; Set StackPtr to Ramend
	
		SetPortIOStat LCD16080_IOPORT, 0b00000000   ; iiiiiiii // preset, will change during operation 
		SetPortIOStat LCD16080_BITS  , 0b10011111	; xxxxoooo // set (see LCD16080_BITS)

		rcall LCD16080_Init
		rcall LCD16080_TextMode

	MAIN:

			LCD16080_Write LCD_WRITED, ':'
			LCD16080_Write LCD_WRITED, '-'
			LCD16080_Write LCD_WRITED, ')'
			LCD16080_Write LCD_WRITED, ' '

	MAINLOOP:

			sbi LCD16080_BITS, PA7 // blink LED
			rcall WAIT_100ms
			cbi LCD16080_BITS, PA7
			rcall WAIT_100ms

		rjmp MAINLOOP


;---------------------------------------------------------------
; end of application code
;---------------------------------------------------------------

; include procedures
.include "wait.inc"
.include "LCD16080.inc"


.exit
